merge 1:1 stkcd year using "D:\论文\沪深港通更新\绿色技术专利.dta" 
 keep  if _merge==3
 drop _merge 
 
 merge 1:1 stkcd year using "D:\论文\沪深港通更新\绿色专利获得数.dta" 
 keep if _merge==3
 drop _merge
 
 
 gen treat=0
replace treat=1 if  IndustryCode=="B06"
replace treat=1 if  IndustryCode=="B07"
replace treat=1 if  IndustryCode=="B08"
replace treat=1 if  IndustryCode=="B09"
replace treat=1 if  IndustryCode=="B10"
replace treat=1 if  IndustryCode=="B12"
replace treat=1 if  IndustryCode=="D44"
replace treat=1 if  IndustryCode=="E48"
replace treat=1 if  IndustryCode=="C25"

gen post=0
replace post=1 if year>=2012
gen did=treat*post
drop patent 



 gen patent=ln(当年独立申请的绿色发明数量+当年独立申请的绿色实用新型数量+当年联合申请的绿色发明数量+当年联合申请的绿色实用新型数量+1)
gen patent1=ln(当年独立获得的绿色发明数量+当年独立获得的绿色实用新型数量+当年联合获得的绿色发明数量+当年联合获得的绿色实用新型数量+1)
 
 encode stkcd,gen(id)
 
 gen lev=负债合计/资产总计
 gen size=ln(资产总计)
 gen age=ln(year-EstablishDate)
 drop if age==0

gen roa=净利润/资产总计
 gen growth=营业收入增长率B
 gen board=ln(董事人数)
 gen indr=其中独立董事人数/董事人数
 gen top1= LargestHolderRate
gen roe=净利润/(资产总计-负债合计)
 
 merge 1:1 stkcd  year using "D:\论文\自贸区与劳动收入份额\期末现金及现金等价物期末余额.dta" 
keep if _merge==3
drop _merge 


gen cash=期末现金及现金等价物余额/资产总计

gen dual=0
replace dual=1 if 董事长与总经理兼任情况==1

sum patent patent1 lev size age roa growth board indr top1 cash dual 
winsor2 patent patent1  lev size age roa growth board indr top1 cash,replace
 
 
 xtset id year
 
 gen big4=0
 replace big4=1 if 审计师是否来自四大会计师事务所=="Y"
 
 ***描述性统计
logout, save(tab_stat1) word replace dec(4):         ///  
            tabstat  patent patent1 did lev size age roa growth board top1   , ///
                    s(N mean sd min max)        ///
                          f(%10.4f) c(s)
 ***相关性分析
 logout, save(tab_stat1) word replace dec(4):         ///  
pwcorr_a   patent patent1 did lev size age roa growth board top1 ,  star1(0.01) star5(0.05) star10(0.1)  
 
 ***vif检验
 reg  patent did  lev size age roa growth  board top1
  logout, save(tab_stat1) word replace dec(4):         ///  
estat vif
 
 
 ***基准回归
 xtreg  patent did i.industry i.year,fe
  outreg2 using 111.doc,replace tstat dec(4)

  xtreg patent did  lev size i.industry i.year,fe 
    outreg2 using 111.doc, tstat dec(4)

  xtreg patent did  lev size age roa  i.industry i.year,fe 
   outreg2 using 111.doc, tstat dec(4)
 xtreg patent did  lev size age roa growth  board top1 i.industry i.year,fe 
 outreg2 using 111.doc, tstat dec(4)

  
 
 ****平行趋势
 gen period=year-2012
 
gen per_3=(period==-3&treat==1)
gen per_2=(period==-2&treat==1)
gen per_1=(period==-1&treat==1)
gen current=(period==0&treat==1)
gen post_1=(period==1&treat==1)
gen post_2=(period==2&treat==1)
gen post_3=(period==3&treat==1)
gen post_4=(period==4&treat==1)
gen post_5=(period==5&treat==1)
gen post_6=(period==6&treat==1)
gen post_7=(period==7&treat==1)
gen post_8=(period==8&treat==1)
 
xtreg patent   per_2 per_1 current  post_1  post_2 post_3 post_4  post_5 post_6 post_7 post_8 lev size age roa growth  board top1 i.industry i.year,fe 

 outreg2 using 111.doc,replace tstat dec(4)

coefplot, baselevels ///
keep(per_2 per_1 current post_1 post_2 post_3 post_4 post_5 post_6  post_7 post_8) ///
vertical ///转置图形
coeflabels( per_2=-2 per_1=-1   ///
current=0 post_1=1 post_2=2 post_3=3 post_4=4 post_5=5 post_6=6  post_7=7 post_8=8) /// 
yline(0,lwidth(vthin) lpattern(solid) lcolor(teal)) ///
xline(5,lwidth(vthin) lpattern(solid) lcolor(teal)) ///
ylabel(-0.03(0.01)0.03,labsize(*0.85) angle(0)) xlabel(,labsize(*0.85)) ///
ytitle("Coefficients") ///
msymbol(O) msize(small) mcolor(gs1) ///plot样式
addplot(line @b @at,lcolor(gs1) lwidth(medthick)) ///增加点之间的连线
ciopts(recast(rline) lwidth(thin) lpattern(dash) lcolor(gs2)) ///置信区间样式
graphregion(color(white)) //白底	

 
 
****安慰剂检验
 *-安慰剂检验-虚构处理组
set matsize 10000
mat b = J(1000,1,0) //* 系数矩阵
mat se = J(1000,1,0) //* 标准误矩阵 
mat p = J(1000,1,0) //* P值矩阵

*循环1000次
forvalues i=1/1000{ 
 use  "D:\论文\调用数据\绿色信贷与企业绿色技术创新\数据集.dta" , clear
 xtset id year  //面板数据声明
 keep if year==2020  //保留一期数据
 sample 163, count   //随机抽取237个样本
 keep id  //得到所抽取样本的id编号
 save "D:\论文\调用数据\绿色信贷与企业绿色技术创新\match_id.dta",replace   //另存id编号数据
 merge 1:m id using  "D:\论文\调用数据\绿色信贷与企业绿色技术创新\数据集.dta" //与原数据匹配
 gen treat1 = (_merge == 3) //将所抽取样本赋值为1，其余为0，得到政策分组虚拟变量
 gen time = (year >= 2012) //生成政策时间虚拟变量
 gen did3 = treat1*time
 xtreg patent did3  lev size age roa growth  board top1 i.industry i.year,fe 

 * 将回归结果赋值到对应矩阵的对应位置
 mat b[`i',1] = _b[did]
 mat se[`i',1] = _se[did]

 * 计算P值并赋值于矩阵
 mat p[`i',1] = 2*ttail(e(df_r), abs(_b[did]/_se[did]))
}

* 矩阵转化为向量
svmat b, names(coef)
svmat se, names(se)
svmat p, names(pvalue)
* 删除空值并添加标签
drop if pvalue1 == .
label var pvalue1 p值
label var coef1 估计系数
keep coef1 se1 pvalue1 

tw kdensity coef1, xline(0)

twoway (kdensity coef1,yaxis(1)) (scatter pvalue1 coef1, msymbol(smcircle_hollow) mcolor(blue) yaxis(2)), ///
title("Placebo Test") ///
xlabel(-0.3(0.1)0.3) ylabel(,angle(0)) ///
xline(0.1222, lwidth(vthin) lp(shortdash)) xtitle("系数") ///
yline(0.1,lwidth(vthin) lp(dash)) ytitle("核密度") ///
legend(label(1 "核密度") label( 2 "p值")) ///
plotregion(style(none)) ///无边框
graphregion(color(white)) //白底

 
 ***倾向得分匹配
 
 set seed 0001
gen tmp=runiform()
sort tmp
psmatch2 treat lev size age roa growth  board top1   , radius cal(0.01) ate ties logit common  
pstest lev size age roa growth  board top1 , both graph  
psgraph


 xtreg patent did  lev size age roa growth  board top1 i.industry i.year if _weight!=.,fe 
 outreg2 using 111.doc,replace tstat dec(4)

psmatch2 treat lev size age roa growth  board top1  ,  kernel ate ties logit common 
pstest lev size age roa growth  board top1 , both graph  

xtreg patent did  lev size age roa growth  board top1 i.industry i.year if _weight!=.,fe 
 outreg2 using 111.doc,tstat dec(4)

***更换衡量方式
xtreg patent1 did  lev size age roa growth  board top1 i.industry i.year   ,fe 
 outreg2 using 111.doc,replace tstat dec(4)
***缩短样本窗期
xtreg patent did  lev size age roa growth  board top1 i.industry i.year if year<=2018   ,fe 
 outreg2 using 111.doc, tstat dec(4)
xtreg patent1 did  lev size age roa growth  board top1 i.industry i.year if year<=2018  ,fe 
 outreg2 using 111.doc, tstat dec(4)

 ****地区异质性
 xtreg patent did  lev size age roa growth  board top1 i.industry i.year if 区域=="东部",fe 
  outreg2 using 111.doc,replace tstat dec(4)
 xtreg patent did  lev size age roa growth  board top1 i.industry i.year if 区域=="中部" ,fe 
  outreg2 using 111.doc, tstat dec(4)
 xtreg patent did  lev size age roa growth  board top1 i.industry i.year if 区域=="西部" ,fe 
  outreg2 using 111.doc, tstat dec(4)

 
 
 
 **产权性质
gen SOE=0
replace SOE=1 if EquityNature=="国企"

 xtreg patent did  lev size age roa growth  board top1 i.industry i.year if SOE==1,fe 
  outreg2 using 111.doc,replace tstat dec(4)
 xtreg patent did  lev size age roa growth  board top1 i.industry i.year if SOE==0,fe 
  outreg2 using 111.doc, tstat dec(4)


xtreg patent did  lev size age roa growth  board top1 i.industry i.year if size>=21.96,fe 
  outreg2 using 111.doc,replace  tstat dec(4)
 xtreg patent did  lev size age roa growth  board top1 i.industry i.year if size<21.96,fe 
  outreg2 using 111.doc, tstat dec(4)

